// import { Component, Inject, OnInit, PLATFORM_ID } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';
// import { EChartsOption } from 'echarts';
// import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
// import { ModalContentComponent } from './modal-content/modal-content.component';

// @Component({
//   selector: 'app-root',
//   templateUrl: './app.component.html',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements OnInit {
//   chartOption: EChartsOption | null = null;

//   drillDownChartOption: EChartsOption | null = null;
//   modalRef!: BsModalRef;

//   data: any[] = [
//     {
//       name: 'Fruits',
//       total: 300,
//       drilldown: [
//         { name: 'Apples', value: 120 },
//         { name: 'Oranges', value: 80 },
//         { name: 'Bananas', value: 100 },
//       ],
//     },
//     {
//       name: 'Vegetables',
//       total: 200,
//       drilldown: [
//         { name: 'Tomatoes', value: 90 },
//         { name: 'Peppers', value: 60 },
//         { name: 'Carrots', value: 50 },
//       ],
//     },
//   ];

//   constructor(
//     @Inject(PLATFORM_ID) private platformId: Object,
//     private modalService: BsModalService
//   ) {}

//   ngOnInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//       this.chartOption = {
//         tooltip: {
//           trigger: 'axis',
//           axisPointer: { type: 'shadow' },
//         },
//         xAxis: {
//           type: 'category',
//           data: ['Item A', 'Item B', 'Item C', 'Item D', 'Item E', 'Item F'],
//         },
//         yAxis: { type: 'value' },
//         series: [{ data: [120, 200, 150, 100, 270, 180], type: 'bar' }],
//       };

//       this.setChartOptions(
//         this.data.map((item) => ({
//           name: item.name,
//           value: item.total,
//         }))
//       );
//     }
//   }

//   onChartClick(event: any): void {
//     const itemData = event.seriesName;
//     // Data for the modal can be fetched or calculated here based on the itemData
//     this.openModalWithData(this.fetchDataForItem(itemData));
//   }

//   fetchDataForItem(itemName: string) {
//     // This is where you fetch or construct the data based on the bar clicked
//     return [
//       { attribute: 'Detail 1', value: 'Data A' },
//       { attribute: 'Detail 2', value: 'Data B' },
//       { attribute: 'Detail 3', value: 'Data C' },
//       { attribute: 'Detail 4', value: 'Data A' },
//       { attribute: 'Detail 5', value: 'Data B' },
//       { attribute: 'Detail 6', value: 'Data C' },
//     ];
//   }

//   openModalWithData(data: any): void {
//     const initialState = { list: data };
//     this.modalRef = this.modalService.show(ModalContentComponent, {
//       initialState,
//     });
//     this.modalRef.content.closeBtnName = 'Close';
//   }

//   //----------------------------------------------------------------
//   setChartOptions(data: any[]): void {
//     this.drillDownChartOption = {
//       tooltip: {
//         trigger: 'item',
//         formatter: '{a} <br/>{b} : {c}',
//       },
//       xAxis: {
//         type: 'category',
//         data: data.map((item) => item.name),
//       },
//       yAxis: {
//         type: 'value',
//       },
//       series: [
//         {
//           name: 'Categories',
//           type: 'bar',
//           data: data,
//           label: {
//             show: true,
//             position: 'inside',
//           },
//         },
//       ],
//     };
//   }

//   onDrillDownChartClick(event: any): void {
//     const selectedItem = this.data.find((item) => item.name === event.name);
//     if (selectedItem && selectedItem.drilldown) {
//       this.setChartOptions(selectedItem.drilldown);
//     }
//   }
// }

import { Component, Inject, OnInit, PLATFORM_ID } from '@angular/core';
import { isPlatformBrowser } from '@angular/common';
import { EChartsOption } from 'echarts';
import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
import { ModalContentComponent } from './modal-content/modal-content.component';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
})
export class AppComponent implements OnInit {
  chartOption: EChartsOption | null = null;
  drillDownChartOption: EChartsOption | null = null;
  modalRef!: BsModalRef;

  data: any[] = [
    {
      name: 'Fruits',
      total: 300,
      drilldown: [
        { name: 'Apples', value: 120 },
        { name: 'Oranges', value: 80 },
        { name: 'Bananas', value: 100 },
      ],
    },
    {
      name: 'Vegetables',
      total: 200,
      drilldown: [
        { name: 'Tomatoes', value: 90 },
        { name: 'Peppers', value: 60 },
        { name: 'Carrots', value: 50 },
      ],
    },
    {
      name: 'Dairy',
      total: 150,
      drilldown: [
        { name: 'Milk', value: 70 },
        { name: 'Cheese', value: 80 },
      ],
    },
    {
      name: 'Ornaments',
      total: 250,
      drilldown: [
        { name: 'Gold', value: 150 },
        { name: 'Silver', value: 100 },
      ],
    },
    {
      name: 'Beverages',
      total: 180,
      drilldown: [
        { name: 'Coffee', value: 100 },
        { name: 'Tea', value: 80 },
      ],
    },
    {
      name: 'Snacks',
      total: 220,
      drilldown: [
        { name: 'Chips', value: 120 },
        { name: 'Nuts', value: 100 },
      ],
    },
  ];

  constructor(
    @Inject(PLATFORM_ID) private platformId: Object,
    private modalService: BsModalService
  ) {}

  ngOnInit(): void {
    if (isPlatformBrowser(this.platformId)) {
      this.setMainChartOptions();
    }
  }

  setMainChartOptions(): void {
    this.chartOption = {
      title: {
        text: 'Drilldown Bar Chart',
        left: 'center', // Center align the title
        textStyle: {
          fontWeight: 'bold', // Make title text bold
          fontSize: 18, // Increase the font size
        },
      },
      tooltip: {
        trigger: 'axis',
        axisPointer: { type: 'shadow' },
      },
      xAxis: {
        type: 'category',
        data: this.data.map((item) => item.name),
        name: 'Category Types',
        nameTextStyle: {
          fontWeight: 'bold', // Make x-axis label bold
          fontSize: 16, // Increase the font size
        },
        nameLocation: 'middle', // Centers the axis name
        nameGap: 30, // Increase gap to position the name better
      },
      yAxis: {
        type: 'value',
        name: 'Bar Chart',
        nameTextStyle: {
          fontWeight: 'bold', // Make y-axis label bold
          fontSize: 16, // Increase the font size
        },
        nameLocation: 'middle', // Centers the axis name
        nameRotate: 90, // Rotate to align vertically
        nameGap: 50, // Adjust gap to avoid clipping with axis labels
      },
      series: [
        {
          name: 'Categories',
          type: 'bar',
          data: this.data.map((item) => ({
            name: item.name,
            value: item.total,
          })),
          label: {
            show: true,
            position: 'inside',
          },
        },
      ],
    };
    this.drillDownChartOption = null; // Initially hide the drilldown chart
  }

  onChartClick(event: any): void {
    const selectedItem = this.data.find((item) => item.name === event.name);
    if (selectedItem && selectedItem.drilldown) {
      this.setDrillDownChartOptions(selectedItem.drilldown);
    }
  }

  setDrillDownChartOptions(drilldownData: any[]): void {
    this.drillDownChartOption = {
      tooltip: {
        trigger: 'item',
        formatter: '{a} <br/>{b} : {c}',
      },
      xAxis: {
        type: 'category',
        data: drilldownData.map((item) => item.name),
      },
      yAxis: {
        type: 'value',
      },
      series: [
        {
          name: 'Details',
          type: 'bar',
          data: drilldownData,
          label: {
            show: true,
            position: 'inside',
          },
        },
      ],
    };
    this.chartOption = null; // Optionally hide the main chart when displaying the drilldown
  }

  onDrillDownChartClick(event: any): void {
    // Handle click on the drilldown chart (e.g., navigating back to the main chart)
    this.setMainChartOptions(); // This will show the main chart again
  }
}
